emit

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.core.parser.java_cup
Class emit

    java.lang.Object
      weka.core.parser.java_cup.emit

    public class emit

extends java.lang.Object

This class handles emitting generated code for the resulting parser. The various parse tables must be constructed, etc. before calling any routines in this class.

Three classes are produced by this code:

symbol constant class
  this contains constant declarations for each terminal (and optionally each non-terminal).
action class
  this non-public class contains code to invoke all the user actions that were embedded in the parser specification.
parser class
  the specialized parser class consisting primarily of some user supplied general and initialization code, and the parse tables.

Three parse tables are created as part of the parser class:

production table
  lists the LHS non terminal number, and the length of the RHS of each production.
action table
  for each state of the parse machine, gives the action to be taken (shift, reduce, or error) under each lookahead symbol.
reduce-goto table
  when a reduce on a given production is taken, the parse stack is popped back a number of elements corresponding to the RHS of the production. This reveals a prior state, which we transition out of under the LHS non terminal symbol for the production (as if we had seen the LHS symbol rather than all the symbols matching the RHS). This table is indexed by non terminal numbers and indicates how to make these transitions.

In addition to the method interface, this class maintains a series of public global variables and flags indicating how misc. parts of the code and other output is to be produced, and counting things such as number of conflicts detected (see the source code and public variables below for more details).

This class is "static" (contains only static data and methods).

Version:
  last update: 11/25/95
Author:
  Scott Hudson
See Also:
  `weka.core.parser.java_cup.main`

Field Summary
`static java.lang.String` | `action_code` User declarations for direct inclusion in user action class.
`static long` | `action_code_time` Time to produce action code class.
`static long` | `action_table_time` Time to produce the action table.
`static java.lang.String` | `class_type_argument` TUM changes; proposed by Henning Niss 20050628: Type arguments for class declaration
`static long` | `goto_table_time` Time to produce the reduce-goto table.
`static java.util.Stack` | `import_list` List of imports (Strings containing class names) to go with actions.
`static java.lang.String` | `init_code` User code for user_init() which is called during parser initialization.
`static int` | `not_reduced` Count of the number on non-reduced productions found.
`static boolean` | `nowarn` Do we skip warnings?
`static int` | `num_conflicts` Number of conflict found while building tables.
`static java.lang.String` | `package_name` Package that the resulting code goes into (null is used for unnamed).
`static java.lang.String` | `parser_class_name` Name of the generated parser class.
`static java.lang.String` | `parser_code` User declarations for direct inclusion in parser class.
`static long` | `parser_time` Time to produce parser class.
`static java.lang.String` | `prefix` The prefix placed on names that pollute someone else's name space.
`static long` | `production_table_time` Time to produce the production table.
`static java.lang.String` | `scan_code` User code for scan() which is called to get the next Symbol.
`static production` | `start_production` The start production of the grammar.
`static java.lang.String` | `symbol_const_class_name` Name of the generated class for symbol constants.
`static long` | `symbols_time` Time to produce symbol constant class.
`static int` | `unused_non_term` Count of unused non terminals.
`static int` | `unused_term` Count of unused terminals.

Method Summary
`static void` | `clear()`
`static boolean` | `lr_values()` whether or not to emit code for left and right values
`static void` | `parser(java.io.PrintWriter out, parse_action_table action_table, parse_reduce_table reduce_table, int start_st, production start_prod, boolean compact_reduces, boolean suppress_scanner)` Emit the parser subclass with embedded tables.
`static void` | `symbols(java.io.PrintWriter out, boolean emit_non_terms, boolean sym_interface)` Emit code for the symbol constant class, optionally including non terms, if they have been requested.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### prefix

    public static java.lang.String prefix

  The prefix placed on names that pollute someone else's name space.

### package_name

    public static java.lang.String package_name

  Package that the resulting code goes into (null is used for unnamed).

### symbol_const_class_name

    public static java.lang.String symbol_const_class_name

  Name of the generated class for symbol constants.

### parser_class_name

    public static java.lang.String parser_class_name

  Name of the generated parser class.

### class_type_argument

    public static java.lang.String class_type_argument

  TUM changes; proposed by Henning Niss 20050628: Type arguments for class declaration

### action_code

    public static java.lang.String action_code

  User declarations for direct inclusion in user action class.

### parser_code

    public static java.lang.String parser_code

  User declarations for direct inclusion in parser class.

### init_code

    public static java.lang.String init_code

  User code for user_init() which is called during parser initialization.

### scan_code

    public static java.lang.String scan_code

  User code for scan() which is called to get the next Symbol.

### start_production

    public static production start_production

  The start production of the grammar.

### import_list

    public static java.util.Stack import_list

  List of imports (Strings containing class names) to go with actions.

### num_conflicts

    public static int num_conflicts

  Number of conflict found while building tables.

### nowarn

    public static boolean nowarn

  Do we skip warnings?

### not_reduced

    public static int not_reduced

  Count of the number on non-reduced productions found.

### unused_term

    public static int unused_term

  Count of unused terminals.

### unused_non_term

    public static int unused_non_term

  Count of unused non terminals.

### symbols_time

    public static long symbols_time

  Time to produce symbol constant class.

### parser_time

    public static long parser_time

  Time to produce parser class.

### action_code_time

    public static long action_code_time

  Time to produce action code class.

### production_table_time

    public static long production_table_time

  Time to produce the production table.

### action_table_time

    public static long action_table_time

  Time to produce the action table.

### goto_table_time

    public static long goto_table_time

  Time to produce the reduce-goto table.

Method Detail

### lr_values

    public static boolean lr_values()

  whether or not to emit code for left and right values

### clear

    public static void clear()

### symbols

    public static void symbols(java.io.PrintWriter out,
                               boolean emit_non_terms,
                               boolean sym_interface)

  Emit code for the symbol constant class, optionally including non terms, if they have been requested.

  Parameters:
    `out` - stream to produce output on.
    `emit_non_terms` - do we emit constants for non terminals?
    `sym_interface` - should we emit an interface, rather than a class?

### parser

    public static void parser(java.io.PrintWriter out,
                              parse_action_table action_table,
                              parse_reduce_table reduce_table,
                              int start_st,
                              production start_prod,
                              boolean compact_reduces,
                              boolean suppress_scanner)
                       throws internal_error

  Emit the parser subclass with embedded tables.

  Parameters:
    `out` - stream to produce output on.
    `action_table` - internal representation of the action table.
    `reduce_table` - internal representation of the reduce-goto table.
    `start_st` - start state of the parse machine.
    `start_prod` - start production of the grammar.
    `compact_reduces` - do we use most frequent reduce as default?
    `suppress_scanner` - should scanner be suppressed for compatibility?
  Throws:
    `internal_error`

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD